<?php
namespace TYPO3\Surf\Domain\Model;

/*                                                                        *
 * This script belongs to the TYPO3 project "TYPO3 Surf"                  *
 *                                                                        *
 *                                                                        */

/**
 * Representing a failed deployment
 *
 * This class does nothing
 *
 */
class FailedDeployment extends Deployment
{
    /**
     * Constructor
     *
     * @param string $name
     */
    public function __construct($name = null)
    {
        parent::__construct($name);
        $this->releaseIdentifier = null;
    }

    /**
     * Initialize the deployment
     * noop
     */
    public function initialize()
    {
    }

    /**
     * Run this deployment
     * noop
     */
    public function deploy()
    {
    }

    /**
     * Simulate this deployment without executing tasks
     * noop
     */
    public function simulate()
    {
    }

    /**
     * Get the current deployment status
     *
     * @return int One of the Deployment::STATUS_* constants
     */
    public function getStatus()
    {
        return self::STATUS_UNKNOWN;
    }
}
